/*
 *  body.cpp
 *  creature
 *
 *  Created by Andrea Bradshaw on 9/18/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "body.h"


body::body(){
	radius	= 20;
	diff	= 0;
	
	pos = ofPoint( -55, 0 );
	prevPos = ofPoint( 0 , 0 );
	
	catchUpSpeed = 0.05f;
	angle = 0.0f;
	
	
}

//--------------------------------------------------------

void body::update( float x, float y ){
	
	radius = 30 + 10 * sin( ofGetElapsedTimef() * 3.5 );
	
	pos.x = catchUpSpeed * x + (1-catchUpSpeed) * pos.x; 
	pos.y = catchUpSpeed * y + (1-catchUpSpeed) * pos.y; 
	
	float dx = pos.x - prevPos.x;
	float dy = pos.y - prevPos.y;
	
	angle = atan2(dy, dx);
	
	prevPos.x = pos.x;
	prevPos.y = pos.y;	
}

//--------------------------------------------------------
void body::draw(){
		
	ofPushMatrix();
	ofTranslate(pos.x, pos.y, 1);
	ofRotateZ(angle * RAD_TO_DEG);
	
		ofFill();
		ofSetColor( 75, 75, 75);
		ofCircle( -( radius + 30 ), 0, radius );
		ofCircle( -( radius + 10 ), 0, radius*.75 );
	
	ofPopMatrix();
}














