/*
 *  head.cpp
 *  creature
 *
 *  Created by Andrea Bradshaw on 9/18/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "head.h"

head::head(){
	catchUpSpeed = 0.06f;
	radius = 15;
	
	pos.set(0,0);
	prevPos.set(0,0);
	
	noseAngle = 0;
}

//--------------------------------------------------------

void head::update( float catchX, float catchY ){
	pos.x = catchUpSpeed * catchX + (1-catchUpSpeed) * pos.x; 
	pos.y = catchUpSpeed * catchY + (1-catchUpSpeed) * pos.y; 
	
	float dx = pos.x - prevPos.x;
	float dy = pos.y - prevPos.y;
	
	angle = atan2(dy, dx);
	
	prevPos.x = pos.x;
	prevPos.y = pos.y;
	
	noseAngle = ofMap( sin(ofGetElapsedTimef()*4.5), -1, 1, -PI/16, PI/16, false );
}

//--------------------------------------------------------
void head::draw(){
	ofPushMatrix();
		ofTranslate(pos.x, pos.y, 1);
		ofRotateZ(angle * RAD_TO_DEG);
		ofFill();
			
		ofSetColor( 255, 175, 175);
		ofCircle( -5*radius/2, radius*.75, 8);
		ofCircle( -5*radius/2, -radius*.75, 8);
	
		ofSetColor( 100, 100, 100 );
	
		ofCircle( -2*radius, 0, radius);
	
		ofSetColor( 255, 255, 255 );
		ofCircle( -radius - 8, 6, 3 );
		ofCircle( -radius - 8, -6, 3 );
		ofSetColor( 0, 0, 0);
		ofCircle( -radius-7, 6, 1 );
		ofCircle( -radius-7, -6, 1 );
	
		
	
		ofPushMatrix();
			ofTranslate( -2*radius, 0, 0 );
			ofRotateZ( noseAngle * RAD_TO_DEG );
			ofSetColor( 0, 0, 0 );
			ofCircle( radius, 0, 2 );
			ofLine( radius, 0, 3*radius/2, radius);
			ofLine( radius, 0, 3*radius/2, -radius);
			ofLine( radius, 0, 3*radius/4, radius);
			ofLine( radius, 0, 3*radius/4, -radius);
		ofPopMatrix();
	
		
	
		ofTranslate(0, 0, -1);
	
	ofPopMatrix();
}