/*
 *  mouse.cpp
 *  creature
 *
 *  Created by Andrea Bradshaw on 9/18/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

//--------------------------------------------------------

#include "mouse.h"

mouse::mouse(){
	
	myHead = head();
	myBody = body();
	myTail = tail();
	
	pos.set( 0, 0 );
	prevPos.set( 0, 0 );
	
	catchUpSpeed = 0.07f;

}

//--------------------------------------------------------

void mouse::update( int catchX, int catchY ){
	
	pos.x = catchUpSpeed * catchX + (1-catchUpSpeed) * pos.x; 
	pos.y = catchUpSpeed * catchY + (1-catchUpSpeed) * pos.y; 
	
	float dx = pos.x - prevPos.x;
	float dy = pos.y - prevPos.y;
	
	angle = atan2(dy, dx);
	
	prevPos.x = pos.x;
	prevPos.y = pos.y;
	
	myHead.update( catchX, catchY );
	myBody.update( catchX, catchY );
	myTail.update( catchX, catchY, myBody.radius );
}

//--------------------------------------------------------
void mouse::draw(){
	//ofPushMatrix();
	//	ofTranslate(pos.x, pos.y, 0);
	//	ofRotateZ(angle * RAD_TO_DEG);
		
		
		
		myTail.draw();
		myBody.draw();
		myHead.draw();
		
	
	//ofPopMatrix();
	
	
		
}