/*
 *  tail.cpp
 *  creature
 *
 *  Created by Andrea Bradshaw on 9/18/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "tail.h"

tail::tail(){
	pos.set( 300, 300, 0 );
	numPoints = 10;
	
	widthMod = 10;
	//L = widthMod * numPoints;
	L = 50;
	
	E = 200;
	I = (PI * pow(2, 4) )/ 4;
	P = 30;
	A = 20;
	B = 20;
	
	for ( int i = 0; i < numPoints; i++ ){
		tailPoints [ i ] = ofPoint( widthMod * i, 0 );
	}
	 
	catchUpSpeed = 0.04f;
	
	offset = 0;
}

//--------------------------------------------------------

void tail::update( int x, int y, int radius ){
	
	offset = radius + 40;
	
	pos.x = catchUpSpeed * x + (1-catchUpSpeed) * pos.x; 
	pos.y = catchUpSpeed * y + (1-catchUpSpeed) * pos.y; 
	
	float dx = pos.x - prevPos.x;
	float dy = pos.y - prevPos.y;
	
	angle = atan2(dy, dx) + PI;
	
	prevPos.x = pos.x;
	prevPos.y = pos.y;	
	
	P = sin(ofGetElapsedTimef()*4 *PI);
	
	for ( int i = 0; i < numPoints; i++ ){
		tailPoints[ i ].y = (P/( 6 * E * I )) * (3 * pow(L, 3) - 2 * pow(L, 3) - pow(L, 3) - pow(floor( i * widthMod), 3 ));
		printf("Y: %f \n", tailPoints[ i ].y );
	}

}

//--------------------------------------------------------
void tail::draw(){
	ofPushMatrix();
	ofTranslate(pos.x, pos.y, 1);
	ofRotateZ(angle * RAD_TO_DEG);
		ofFill();
		ofSetColor(255, 175, 175);
		ofCircle( tailPoints[ 0 ].x+offset, tailPoints[ 0 ].y, 5 );
	
	
		ofSetColor(255,255,255);
	
		ofNoFill();
		ofBeginShape();
		for ( int i = 0; i < numPoints; i++ ){
			ofVertex( tailPoints[ i ].x+offset, tailPoints[ i ].y );
		}
		ofEndShape();

	ofPopMatrix();
	
	
}